/* Device Manager Lib
 * Copyright Pu Bo 2001 */
#ifndef _DEV_MGR_H
#define _DEV_MGR_H

#include "MemPool.h"

/* definitions */
#define LONG_ID(c1,c2,c3,c4) ((((unsigned long)(c1)&0x00ff)<<24)\
		|(((unsigned long)(c2)&0x00ff)<<16)\
		|(((unsigned long)(c3)&0x00ff)<<8)\
		|(unsigned long)(c4)&0x00ff)

typedef unsigned long DeviceId;
typedef unsigned long InterfaceId;

typedef struct {
	InterfaceId mID;
	const MemPtr mInterfaceP;
}InterfaceRec;

typedef struct {
	DeviceId mID;
	unsigned short mNumInterfaces;
	const InterfaceRec far *mInterfaces;
}DeviceRec;

typedef const DeviceRec far * DevicePtr;

typedef enum {
	kDMNoErr,
	kDMErrDevNonExist,
	kDMErrInterfaceNonExist,
	KDMErrMem,
	KDMErrDevAlreadyInstalled
}DMErr;

/* functions */
DMErr DMInstallDevice(DevicePtr deviceP);
DMErr DMUninstallDevice(DeviceId devId);
const MemPtr QueryInterface(DeviceId devId,InterfaceId intId);

#endif