/* Mini File System Lib
 *
 * Mini File System implements FileSysInterface
 *
 * Copyright Pu Bo 2001 */
#ifndef _MFS_H
#define _MFS_H

#include "FileSysIfc.h"
#include "FileMgrIfc.h"
#include "DevMgr.h"
#include "BlkDevIfc.h"
#include "INodeIfc.h"
#include "INodeMgrIfc.h"

/* definitions */
#define DID_MFS LONG_ID('M','F','S',' ')
#define MAX_MOUNT_FILE_SYS_NAME 11
#define PATH_DELIMITOR '/'

typedef enum {
	kMFSNoErr,
	kMFSErrCreateFS,
	kMFSErrCreateRoot,
	kMFSErrMem,
	kMFSErrDevFull
}MFSErr;

typedef enum {
	kMFSNull = 0,
	kMFSDirectory,
	kMFSDataFile,
	kMFSMountedFS
}MFSMode;

/* functions */
DMErr InstallMFS(BlkDevIntfPtr blkIfcP,
		INodeIfcPtr iNodeIfcP,
		INodeMgrIfcPtr iNodeMgrIfcP);
DMErr UninstallMFS();

/* MFS specific functions */
MFSErr CreateMFSSystem(const char far *name,unsigned long size);
#endif